/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-05-09 at 14:31:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.libraryagent.v1.model;

/**
 * A single book in the library.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Library Agent API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleExampleLibraryagentV1Book extends com.google.api.client.json.GenericJson {

  /**
   * The name of the book author.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String author;

  /**
   * The resource name of the book. Book names have the form `shelves/{shelf_id}/books/{book_id}`.
   * The name is ignored when creating a book.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Value indicating whether the book has been read.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean read;

  /**
   * The title of the book.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * The name of the book author.
   * @return value or {@code null} for none
   */
  public java.lang.String getAuthor() {
    return author;
  }

  /**
   * The name of the book author.
   * @param author author or {@code null} for none
   */
  public GoogleExampleLibraryagentV1Book setAuthor(java.lang.String author) {
    this.author = author;
    return this;
  }

  /**
   * The resource name of the book. Book names have the form `shelves/{shelf_id}/books/{book_id}`.
   * The name is ignored when creating a book.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * The resource name of the book. Book names have the form `shelves/{shelf_id}/books/{book_id}`.
   * The name is ignored when creating a book.
   * @param name name or {@code null} for none
   */
  public GoogleExampleLibraryagentV1Book setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Value indicating whether the book has been read.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getRead() {
    return read;
  }

  /**
   * Value indicating whether the book has been read.
   * @param read read or {@code null} for none
   */
  public GoogleExampleLibraryagentV1Book setRead(java.lang.Boolean read) {
    this.read = read;
    return this;
  }

  /**
   * The title of the book.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * The title of the book.
   * @param title title or {@code null} for none
   */
  public GoogleExampleLibraryagentV1Book setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public GoogleExampleLibraryagentV1Book set(String fieldName, Object value) {
    return (GoogleExampleLibraryagentV1Book) super.set(fieldName, value);
  }

  @Override
  public GoogleExampleLibraryagentV1Book clone() {
    return (GoogleExampleLibraryagentV1Book) super.clone();
  }

}
