/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-05-09 at 14:31:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.libraryagent.v1.model;

/**
 * Response message for LibraryAgent.ListBooks.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Library Agent API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleExampleLibraryagentV1ListBooksResponse extends com.google.api.client.json.GenericJson {

  /**
   * The list of books.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleExampleLibraryagentV1Book> books;

  /**
   * A token to retrieve next page of results. Pass this value in the ListBooksRequest.page_token
   * field in the subsequent call to `ListBooks` method to retrieve the next page of results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The list of books.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleExampleLibraryagentV1Book> getBooks() {
    return books;
  }

  /**
   * The list of books.
   * @param books books or {@code null} for none
   */
  public GoogleExampleLibraryagentV1ListBooksResponse setBooks(java.util.List<GoogleExampleLibraryagentV1Book> books) {
    this.books = books;
    return this;
  }

  /**
   * A token to retrieve next page of results. Pass this value in the ListBooksRequest.page_token
   * field in the subsequent call to `ListBooks` method to retrieve the next page of results.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A token to retrieve next page of results. Pass this value in the ListBooksRequest.page_token
   * field in the subsequent call to `ListBooks` method to retrieve the next page of results.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public GoogleExampleLibraryagentV1ListBooksResponse setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  @Override
  public GoogleExampleLibraryagentV1ListBooksResponse set(String fieldName, Object value) {
    return (GoogleExampleLibraryagentV1ListBooksResponse) super.set(fieldName, value);
  }

  @Override
  public GoogleExampleLibraryagentV1ListBooksResponse clone() {
    return (GoogleExampleLibraryagentV1ListBooksResponse) super.clone();
  }

}
