/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-05-09 at 14:31:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.libraryagent.v1.model;

/**
 * Response message for LibraryAgent.ListShelves.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Library Agent API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleExampleLibraryagentV1ListShelvesResponse extends com.google.api.client.json.GenericJson {

  /**
   * A token to retrieve next page of results. Pass this value in the ListShelvesRequest.page_token
   * field in the subsequent call to `ListShelves` method to retrieve the next page of results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The list of shelves.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleExampleLibraryagentV1Shelf> shelves;

  static {
    // hack to force ProGuard to consider GoogleExampleLibraryagentV1Shelf used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleExampleLibraryagentV1Shelf.class);
  }

  /**
   * A token to retrieve next page of results. Pass this value in the ListShelvesRequest.page_token
   * field in the subsequent call to `ListShelves` method to retrieve the next page of results.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * A token to retrieve next page of results. Pass this value in the ListShelvesRequest.page_token
   * field in the subsequent call to `ListShelves` method to retrieve the next page of results.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public GoogleExampleLibraryagentV1ListShelvesResponse setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * The list of shelves.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleExampleLibraryagentV1Shelf> getShelves() {
    return shelves;
  }

  /**
   * The list of shelves.
   * @param shelves shelves or {@code null} for none
   */
  public GoogleExampleLibraryagentV1ListShelvesResponse setShelves(java.util.List<GoogleExampleLibraryagentV1Shelf> shelves) {
    this.shelves = shelves;
    return this;
  }

  @Override
  public GoogleExampleLibraryagentV1ListShelvesResponse set(String fieldName, Object value) {
    return (GoogleExampleLibraryagentV1ListShelvesResponse) super.set(fieldName, value);
  }

  @Override
  public GoogleExampleLibraryagentV1ListShelvesResponse clone() {
    return (GoogleExampleLibraryagentV1ListShelvesResponse) super.clone();
  }

}
