/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-05-09 at 14:31:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.libraryagent.v1.model;

/**
 * A Shelf contains a collection of books with a theme.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Library Agent API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleExampleLibraryagentV1Shelf extends com.google.api.client.json.GenericJson {

  /**
   * Output only. The resource name of the shelf. Shelf names have the form `shelves/{shelf_id}`.
   * The name is ignored when creating a shelf.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * The theme of the shelf
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String theme;

  /**
   * Output only. The resource name of the shelf. Shelf names have the form `shelves/{shelf_id}`.
   * The name is ignored when creating a shelf.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Output only. The resource name of the shelf. Shelf names have the form `shelves/{shelf_id}`.
   * The name is ignored when creating a shelf.
   * @param name name or {@code null} for none
   */
  public GoogleExampleLibraryagentV1Shelf setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * The theme of the shelf
   * @return value or {@code null} for none
   */
  public java.lang.String getTheme() {
    return theme;
  }

  /**
   * The theme of the shelf
   * @param theme theme or {@code null} for none
   */
  public GoogleExampleLibraryagentV1Shelf setTheme(java.lang.String theme) {
    this.theme = theme;
    return this;
  }

  @Override
  public GoogleExampleLibraryagentV1Shelf set(String fieldName, Object value) {
    return (GoogleExampleLibraryagentV1Shelf) super.set(fieldName, value);
  }

  @Override
  public GoogleExampleLibraryagentV1Shelf clone() {
    return (GoogleExampleLibraryagentV1Shelf) super.clone();
  }

}
